Subject: Re: bug#24041: 25.1.50; xwidget + -nw mode gives segfault

From: Eli Zaretskii <[email-masked]>
Date: Mon, 22 Aug 2016 21:49:59 +0300

> From: Robert Cochran <[email-masked]>
> Cc: Robert Cochran <[email-masked]>,  [email-masked],  [email-masked]
> Date: Mon, 22 Aug 2016 11:30:15 -0700
> 
> > My only comment is that you could call check_x_display_info with Qnil
> > as its argument.
> 
> I did think about that. But then it arguably does the wrong thing:
> `check_x_display_info` with `Qnil` only signals an error when there have
> never been X windows, eg, opening and closing an X window satisfies the
> check from then on. It no longer crashes in that instance, but I
> personally don't think that's the right behavior; if my starting frame
> isn't capable of displaying an xwidget, say so! Hence checking with the
> current frame.

Joakim, is it certain that the xwidget will always be shown in the
frame that is the selected one at the time make-xwidget is called?

> Thanks for your reassurance! My one gripe about this patch is that I
> didn't figure out how to kill the buffer after xwidget creation failure
> (leaving it seems rather ugly IMO), but I just now realized what I can
> do. As long as it's not considered wrong to kill a mode's buffer on
> error, would you also consider this patch to go along with it?

I'm not sure if this is TRT.  I'd rather erase-buffer at the beginning
of xwidget-webkit-new-session, and leave the buffer alone if we signal
an error.  The buffer might have contents that the user will hate
losing, for diagnostic purposes if nothing else.

Joakim, WDYT?